/****************************************************************
**
** Definition of CannonField class, Qt tutorial 8
**
****************************************************************/

#ifndef BOARD_H
#define BOARD_H

#include <qwidget.h>


class DrawingBoard : public QWidget
{
	// #define Round( x ) ((x)<0 ? (int)((x)-0.499999) : (int)((x)+0.5)) 
	#define Round( x ) (int)((x)+0.5) 
	#define RADTOANG 180.0/M_PI
	#define ANGTORAD M_PI/180.0

    Q_OBJECT
public:
    DrawingBoard( QWidget *parent=0, const char *name=0 );

    int angle() const { return ang; }
	void setAngle( int degrees );
	void getPosition ( int *a, int *b ) { *a = px; *b = py; }
	int getXPos ( ) const { return px; }
	int getYPos ( ) const { return py; }
    QSizePolicy sizePolicy() const;

	/** Drawing primitives **/
	void MidPointLine( int x1, int y1, int x2, int y2, QPainter *p  );
	void testLines( QPainter *p );

signals:
	void changePos( );
	
protected:
    void paintEvent( QPaintEvent * );
	void mouseMoveEvent( QMouseEvent * );
	void resizeEvent ( QResizeEvent * );

private:
    int ang;
	int px, py;
	int w, h;
};


#endif // BOARD_H
